# Copyright(C) 2022 - present MongoDB, Inc.
#
# This program is free software : you can redistribute it and / or modify
# it under the terms of the Server Side Public License, version 1,
# as published by MongoDB, Inc.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
# Server Side Public License for more details.
#
# You should have received a copy of the Server Side Public License
# along with this program.If not, see
# < http://www.mongodb.com/licensing/server-side-public-license>.
#
# As a special exception, the copyright holders give permission to link the
# code of portions of this program with the OpenSSL library under certain
# conditions as described in each individual source file and distribute
# linked combinations including the program with the OpenSSL library.You
# must comply with the Server Side Public License in all respects for
# all of the code used other than as permitted herein.If you modify file(s)
# with this exception, you may extend this exception to your version of the
# file(s), but you are not obligated to do so.If you do not wish to do so,
# delete this exception statement from your version.If you delete this
# exception statement from all source files in the program, then also delete
# it in the license file.
#

# File containing feature flags for sharding features

global:
    cpp_namespace: "mongo"

feature_flags:
  featureFlagGlobalIndexesShardingCatalog:
    description: "Feature flag for enabling sharding catalog features for global indexes"
    cpp_varname: feature_flags::gGlobalIndexesShardingCatalog
    default: false
  featureFlagRangeDeleterService:
    description: "Feature flag protecting instantiation and usages of the range deleter service"
    cpp_varname: feature_flags::gRangeDeleterService
    default: true
    version: 6.2
  featureFlagCollModCoordinatorV3:
    description: "Feature for enabling new coll mod coordinator v3"
    cpp_varname: feature_flags::gCollModCoordinatorV3
    default: true
    version: 6.1
  featureFlagCreateCollectionCoordinatorV3:
    description: "Feature for enabling new createCollection coordinator v3"
    cpp_varname: feature_flags::gCreateCollectionCoordinatorV3
    default: true
    version: 6.2
  # TODO SERVER-68217 remove once 7.0 becomes last LTS
  featureFlagHistoricalPlacementShardingCatalog:
    description: "Feature flag for enabling the storage and access to historical placement data at shards granularity through the Sharding Catalog"
    cpp_varname: feature_flags::gHistoricalPlacementShardingCatalog
    default: true
    version: 7.0
  featureRenameCommitInTransaction:
    description: "Feature flag for enabling the usage of a remote transaction for the commit phase of the rename collection"
    cpp_varname: feature_flags::gRenameCommitInTransaction
    default: true
    version: 7.0
  featureFlagImplicitDDLTimeseriesNssTranslation:
    description: "When enabled, the logic to evaluate whether a DDL is targeting a Timeseries operation
                  will always be executed by the DDL Coordinator (VS doing the evaluation when the command is received by the primary shard).
                  The feature increases causal consistency guarantees, but  it is not backwards-compatible"
    cpp_varname: feature_flags::gImplicitDDLTimeseriesNssTranslation
    default: true
    version: 6.1
  featureFlagConcurrencyInChunkMigration:
    description: "Feature flag for enabling concurrency within a chunk migration"
    cpp_varname: feature_flags::gConcurrencyInChunkMigration
    default: true
    version: 6.3
  featureFlagStopUsingConfigVersion:
  # TODO SERVER-68889 remove once 7.0 becomes last LTS
    description: "Stop using deprecated config version fields to check metadata compatibility between different version"
    cpp_varname: feature_flags::gStopUsingConfigVersion
    default: true
    version: 6.2
  # TODO (SERVER-71309): Remove once 7.0 becomes last LTS.
  featureFlagResilientMovePrimary:
    description: "Enable the resilient coordinator for the movePrimary command in order to improve
                 the tolerance in case of a failure on donor and recipient nodes"
    cpp_varname: feature_flags::gResilientMovePrimary
    default: true
    version: 7.0
  featureFlagConfigSettingsSchema:
    description: "Feature flag for adding schema to config.settings collection"
    cpp_varname: feature_flags::gConfigSettingsSchema
    default: true
    version: 6.2
  featureFlagAutoMerger:
    description: "Feature flag for enabling auto-merging of contiguous chunks belonging to the same shard"
    cpp_varname: feature_flags::gAutoMerger
    default: true
    version: 7.0
  # TODO (SERVER-70396): Remove once 7.0 becomes last LTS
  featureFlagCheckMetadataConsistency:
    description: "Feature flag for checking metadata consistency in the cluster, database or collection"
    cpp_varname: feature_flags::gCheckMetadataConsistency
    default: true
    version: 7.0
  # TODO SERVER-73627: Remove once 7.0 becomes last LTS.
  featureFlagDropCollectionHoldingCriticalSection:
    description: "Feature flag for enabling the new implementation of the dropCollection DDL operation."
    cpp_varname: feature_flags::gDropCollectionHoldingCriticalSection
    default: true
    version: 7.0
  featureFlagCheckForDirectShardOperations:
    description: "Feature flag for checking for direct shard operations."
    cpp_varname: feature_flags::gCheckForDirectShardOperations
    default: true
    version: 7.0
  featureFlagClusterCardinalityParameter:
    description: "Feature flag for enabling the cluster parameter tracking cluster cardinality."
    cpp_varname: feature_flags::gClusterCardinalityParameter
    default: true
    version: 7.0
